/* 
 * $Id: sysctl_impl.h,v 1.4 2002/01/20 22:20:00 mulix Exp $
 */

#ifndef SYSCTL_IMPL_H_
#define SYSCTL_IMPL_H_

#include "sct_ctrl_lib.h"
	     

/* add rule */
int 
sysctl_add_rule(sct_ctrl_t ctrl, int rule_id, sct_rule_when_t when,
		int syscall_id, 
		sct_filter_node_t* filter, sct_action_t* act,
		int enable_rule);

/* delete a rule */
int
sysctl_del_rule(sct_ctrl_t ctrl, int rule_id, sct_rule_when_t when, int syscall_id);

/* enable a rule */
int 
sysctl_enable_rule(sct_ctrl_t ctrl,
		   int rule_id,
		   sct_rule_when_t when,
		   int syscall_id);

/* disable a rule */
int 
sysctl_disable_rule(sct_ctrl_t ctrl,
		    int rule_id,
		    sct_rule_when_t when,
		    int syscall_id);

/* delete all rules for this syscall */
int 
sysctl_del_all_syscall_rules(sct_ctrl_t ctrl, int syscall_id);

/* delete all rules for ALL syscalls */
int 
sysctl_del_all_rules(sct_ctrl_t ctrl);

/* print the current rules */
int
sysctl_print_all_rules(sct_ctrl_t ctrl);

#endif /* SYSCTL_IMPL_H_ */
