/*
 *$Id: arch-linux-kernel.h,v 1.4 2001/10/14 17:30:47 mulix Exp $
 */
#ifndef ARCH_LINUX_KERNEL_H_
#define ARCH_LINUX_KERNEL_H_

#ifndef LINUX_KERNEL
#error "arch-linux-kernel.h included and LINUX_KERNEL not defined!"
#endif

/* malloc/free support */
# include <linux/slab.h>
# include <linux/types.h>
# include <linux/stddef.h>
# include <linux/string.h>
# include <linux/kernel.h>
# include <linux/ctype.h>

#define mem_alloc(foo) kmalloc((foo), GFP_KERNEL)
#define mem_free(foo)  kfree((foo))

/* generic print macro */
# define PPRINT(fmt, args...) printk(fmt, ## args)

# ifdef SCT_RULES_DEBUG 

/* values from include/linux/kernel.h */

#undef KERN_NOTICE
#define KERN_NOTICE "<1>"        /* KERN_ALERT */

#undef KERN_INFO 
#define KERN_INFO "<5>"          /* KERN_NOTICE */

#undef KERN_DEBUG
#define KERN_DEBUG "<5>"         /* KERN_NOTICE */

# endif /* SCT_RULES_DEBUG */

/* assert in kernel space */

#undef assert
#define assert(x) do {if (!(x)) BUG(); } while (0)

#endif /* ARCH_LINUX_KERNEL_H_ */

