/*
 * $Id: device_file.h,v 1.5 2002/01/18 00:46:01 mulix Exp $
 */ 

#ifndef DEVICE_FILE_H_
#define DEVICE_FILE_H_

#include <linux/kernel.h>
#include <linux/types.h>  /* size_t */
#include <linux/fs.h>     /* everything... */

#include "request_buffer.h"
#include "response_buffer.h"

/* merge the two buffers into one, once sct_rules gives us a  */
/* mem buffer to use  */
typedef struct sct_dev_type {
	struct request_buffer req_buf;
	struct response_buffer resp_buf;
	struct semaphore sem;     /* Mutual exclusion */
} sct_dev_t;

/* the major device number for the device file */
extern int sct_major; 

/* the device struct */
extern sct_dev_t sct_dev;

/* the file operations for the device */
extern struct file_operations sct_fops;

#endif /* DEVICE_FILE_H_ */
