/*
 * $Id: request_buffer.h,v 1.2 2002/01/11 13:42:46 mulix Exp $
 */

#ifndef REQUEST_BUFFER_H_
#define REQUEST_BUFFER_H_

#include <linux/kernel.h>

#define REQ_ORIG_BUF_SIZE 1024

struct request_buffer
{
    unsigned char* whead;
    unsigned char data[REQ_ORIG_BUF_SIZE];
    size_t free_space;
    size_t data_size;
}; 

typedef struct request_buffer* req_buf_t;

/* add to the end of the request buffer this user supplied chunk,  */
/* with this size.  */
/* returns 0 on succes, a negative error on failure.  */
/* NOTE: chunk should point into user space memory, add_chunk will  */
/* take care of the copying */
int req_add_chunk(req_buf_t buf, const unsigned char* chunk, size_t sz);

/* does this request buffer contain a whole request packet */
int req_has_whole_packet(req_buf_t buf);

/* get the request buffer's raw data */
unsigned char* req_get_data(req_buf_t buf);

/*get the size of the data */
size_t req_get_data_size(req_buf_t buf);

/* clear this request buffer */
void req_clear(req_buf_t buf);

#endif /* REQUEST_BUFFER_H_ */
