/*
 * $Id: response_buffer.c,v 1.1 2002/01/11 13:42:46 mulix Exp $
 */

#include <asm/uaccess.h>

#include "response_buffer.h"

#define ORIG_RESPONSE_BUF_SIZE 32

int resp_pop_chunk(resp_buf_t buf, unsigned char* uspace_buf, size_t count)
{
	if (!buf)
		return -EINVAL;
    
	count = (buf->data_left > count) ? count : buf->data_left;

	if (count == 0) /* buffer is empty, nothing to do */
		return 0;
    
	if (copy_to_user (uspace_buf, buf->rhead, count)) {
		return -EINVAL;
	}
    
	buf->rhead += count;
	buf->data_left -= count;

	return count;
}

void resp_clear(resp_buf_t buf)
{
	memset(buf->data, 0, ORIG_RESPONSE_BUF_SIZE);
	buf->rhead = buf->data;
	buf->data_left = 0;
}

unsigned char* resp_get_data(resp_buf_t buf)
{
	return buf->data;
}

void resp_set_data_left(resp_buf_t buf, size_t ammount)
{
	buf->data_left = ammount;
}

size_t resp_get_data_left(resp_buf_t buf)
{
	return buf->data_left;
}
