/*
 * $Id: response_buffer.h,v 1.1 2002/01/11 13:42:46 mulix Exp $
 */

#ifndef RESPONSE_BUFFER_H_
#define RESPONSE_BUFFER_H_

#define ORIG_RESPONSE_BUF_SIZE 32

struct response_buffer
{
    unsigned char data[ORIG_RESPONSE_BUF_SIZE];
    unsigned char* rhead;
    size_t data_left;
};

typedef struct response_buffer* resp_buf_t;

/* copy a chunk of size 'count' from the response buffer into this user  */
/* space buffer. returns the number of bytes inactually copied or a negative  */
/* error number on error. 0 is returned if the response buffer is empty  */
int resp_pop_chunk(resp_buf_t buf, unsigned char* uspace_buf, size_t count);

/* clear this response buffer */
void resp_clear(resp_buf_t buf);

/* get the raw data buffer */
unsigned char* resp_get_data(resp_buf_t buf);

/* set the data_left variable */
void resp_set_data_left(resp_buf_t buf, size_t ammount);

/* get how much space is left */
size_t resp_get_data_left(resp_buf_t buf);

#endif /* RESPONSE_BUFFER_H_ */

