/*
 * $Id: syscall_hijack_autogen.c,v 1.38 2002/02/21 03:07:10 chooga Exp $
 */

/* This file is automatically generated - do not edit. */
/* built by './gen_syscalls.pl 256' for Linux. */


#include <asm/errno.h>

#include <linux/types.h>
#include <linux/time.h>
#include <linux/socket.h>
#include <linux/in.h>


/*
 * Stub functions for syscall hijacking.
 */

/* stub function for syscall 'open' (5). */
asmlinkage static int
stub_syscall_5(const char* pathname, int flags, mode_t mode) {
	typedef int
		(*stub_func_5)(const char* pathname, int flags, mode_t mode);
	typedef int
		(*stub_before_func_5)(const char* pathname, int flags, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_5)(int syscall_rc, const char* pathname, int flags, mode_t mode);
	stub_func_5 orig_syscall_func;
	stub_before_func_5 before_func;
	stub_after_func_5 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[5];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_5)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, flags, mode , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_5)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname, flags, mode) : -ENOSYS);

	    after_func = (stub_after_func_5)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname, flags, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'close' (6). */
asmlinkage static int
stub_syscall_6(int fd) {
	typedef int
		(*stub_func_6)(int fd);
	typedef int
		(*stub_before_func_6)(int fd, int* syscall_rc); 
	typedef int
		(*stub_after_func_6)(int syscall_rc, int fd);
	stub_func_6 orig_syscall_func;
	stub_before_func_6 before_func;
	stub_after_func_6 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[6];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_6)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(fd , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_6)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(fd) : -ENOSYS);

	    after_func = (stub_after_func_6)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, fd);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'waitpid' (7). */
asmlinkage static int
stub_syscall_7(pid_t pid, int* status, int options) {
	typedef int
		(*stub_func_7)(pid_t pid, int* status, int options);
	typedef int
		(*stub_before_func_7)(pid_t pid, int* status, int options, int* syscall_rc); 
	typedef int
		(*stub_after_func_7)(int syscall_rc, pid_t pid, int* status, int options);
	stub_func_7 orig_syscall_func;
	stub_before_func_7 before_func;
	stub_after_func_7 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[7];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_7)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pid, status, options , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_7)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pid, status, options) : -ENOSYS);

	    after_func = (stub_after_func_7)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pid, status, options);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'creat' (8). */
asmlinkage static int
stub_syscall_8(const char* pathname, mode_t mode) {
	typedef int
		(*stub_func_8)(const char* pathname, mode_t mode);
	typedef int
		(*stub_before_func_8)(const char* pathname, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_8)(int syscall_rc, const char* pathname, mode_t mode);
	stub_func_8 orig_syscall_func;
	stub_before_func_8 before_func;
	stub_after_func_8 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[8];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_8)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, mode , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_8)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname, mode) : -ENOSYS);

	    after_func = (stub_after_func_8)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'link' (9). */
asmlinkage static int
stub_syscall_9(const char* oldpath, const char* newpath) {
	typedef int
		(*stub_func_9)(const char* oldpath, const char* newpath);
	typedef int
		(*stub_before_func_9)(const char* oldpath, const char* newpath, int* syscall_rc); 
	typedef int
		(*stub_after_func_9)(int syscall_rc, const char* oldpath, const char* newpath);
	stub_func_9 orig_syscall_func;
	stub_before_func_9 before_func;
	stub_after_func_9 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[9];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_9)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldpath, newpath , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_9)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(oldpath, newpath) : -ENOSYS);

	    after_func = (stub_after_func_9)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, oldpath, newpath);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'unlink' (10). */
asmlinkage static int
stub_syscall_10(const char* pathname) {
	typedef int
		(*stub_func_10)(const char* pathname);
	typedef int
		(*stub_before_func_10)(const char* pathname, int* syscall_rc); 
	typedef int
		(*stub_after_func_10)(int syscall_rc, const char* pathname);
	stub_func_10 orig_syscall_func;
	stub_before_func_10 before_func;
	stub_after_func_10 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[10];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_10)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_10)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname) : -ENOSYS);

	    after_func = (stub_after_func_10)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'chdir' (12). */
asmlinkage static int
stub_syscall_12(const char* pathname) {
	typedef int
		(*stub_func_12)(const char* pathname);
	typedef int
		(*stub_before_func_12)(const char* pathname, int* syscall_rc); 
	typedef int
		(*stub_after_func_12)(int syscall_rc, const char* pathname);
	stub_func_12 orig_syscall_func;
	stub_before_func_12 before_func;
	stub_after_func_12 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[12];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_12)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_12)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname) : -ENOSYS);

	    after_func = (stub_after_func_12)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'chmod' (15). */
asmlinkage static int
stub_syscall_15(const char* pathname, mode_t mode) {
	typedef int
		(*stub_func_15)(const char* pathname, mode_t mode);
	typedef int
		(*stub_before_func_15)(const char* pathname, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_15)(int syscall_rc, const char* pathname, mode_t mode);
	stub_func_15 orig_syscall_func;
	stub_before_func_15 before_func;
	stub_after_func_15 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[15];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_15)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, mode , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_15)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname, mode) : -ENOSYS);

	    after_func = (stub_after_func_15)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'lseek' (19). */
asmlinkage static int
stub_syscall_19(int fildes, off_t offset, int whence) {
	typedef int
		(*stub_func_19)(int fildes, off_t offset, int whence);
	typedef int
		(*stub_before_func_19)(int fildes, off_t offset, int whence, int* syscall_rc); 
	typedef int
		(*stub_after_func_19)(int syscall_rc, int fildes, off_t offset, int whence);
	stub_func_19 orig_syscall_func;
	stub_before_func_19 before_func;
	stub_after_func_19 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[19];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_19)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(fildes, offset, whence , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_19)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(fildes, offset, whence) : -ENOSYS);

	    after_func = (stub_after_func_19)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, fildes, offset, whence);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'getpid' (20). */
asmlinkage static int
stub_syscall_20(void) {
	typedef int
		(*stub_func_20)(void);
	typedef int
		(*stub_before_func_20)(int* syscall_rc); 
	typedef int
		(*stub_after_func_20)(int syscall_rc);
	stub_func_20 orig_syscall_func;
	stub_before_func_20 before_func;
	stub_after_func_20 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[20];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_20)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)( &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_20)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)() : -ENOSYS);

	    after_func = (stub_after_func_20)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval );
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'access' (33). */
asmlinkage static int
stub_syscall_33(const char* pathname, int mode) {
	typedef int
		(*stub_func_33)(const char* pathname, int mode);
	typedef int
		(*stub_before_func_33)(const char* pathname, int mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_33)(int syscall_rc, const char* pathname, int mode);
	stub_func_33 orig_syscall_func;
	stub_before_func_33 before_func;
	stub_after_func_33 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[33];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_33)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, mode , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_33)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname, mode) : -ENOSYS);

	    after_func = (stub_after_func_33)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'nice' (34). */
asmlinkage static int
stub_syscall_34(int inc) {
	typedef int
		(*stub_func_34)(int inc);
	typedef int
		(*stub_before_func_34)(int inc, int* syscall_rc); 
	typedef int
		(*stub_after_func_34)(int syscall_rc, int inc);
	stub_func_34 orig_syscall_func;
	stub_before_func_34 before_func;
	stub_after_func_34 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[34];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_34)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(inc , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_34)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(inc) : -ENOSYS);

	    after_func = (stub_after_func_34)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, inc);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'kill' (37). */
asmlinkage static int
stub_syscall_37(pid_t pid, int sig) {
	typedef int
		(*stub_func_37)(pid_t pid, int sig);
	typedef int
		(*stub_before_func_37)(pid_t pid, int sig, int* syscall_rc); 
	typedef int
		(*stub_after_func_37)(int syscall_rc, pid_t pid, int sig);
	stub_func_37 orig_syscall_func;
	stub_before_func_37 before_func;
	stub_after_func_37 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[37];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_37)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pid, sig , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_37)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pid, sig) : -ENOSYS);

	    after_func = (stub_after_func_37)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pid, sig);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'rename' (38). */
asmlinkage static int
stub_syscall_38(const char* oldpath, const char* newpath) {
	typedef int
		(*stub_func_38)(const char* oldpath, const char* newpath);
	typedef int
		(*stub_before_func_38)(const char* oldpath, const char* newpath, int* syscall_rc); 
	typedef int
		(*stub_after_func_38)(int syscall_rc, const char* oldpath, const char* newpath);
	stub_func_38 orig_syscall_func;
	stub_before_func_38 before_func;
	stub_after_func_38 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[38];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_38)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldpath, newpath , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_38)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(oldpath, newpath) : -ENOSYS);

	    after_func = (stub_after_func_38)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, oldpath, newpath);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'mkdir' (39). */
asmlinkage static int
stub_syscall_39(const char* pathname, mode_t mode) {
	typedef int
		(*stub_func_39)(const char* pathname, mode_t mode);
	typedef int
		(*stub_before_func_39)(const char* pathname, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_39)(int syscall_rc, const char* pathname, mode_t mode);
	stub_func_39 orig_syscall_func;
	stub_before_func_39 before_func;
	stub_after_func_39 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[39];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_39)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, mode , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_39)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname, mode) : -ENOSYS);

	    after_func = (stub_after_func_39)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'rmdir' (40). */
asmlinkage static int
stub_syscall_40(const char* pathname) {
	typedef int
		(*stub_func_40)(const char* pathname);
	typedef int
		(*stub_before_func_40)(const char* pathname, int* syscall_rc); 
	typedef int
		(*stub_after_func_40)(int syscall_rc, const char* pathname);
	stub_func_40 orig_syscall_func;
	stub_before_func_40 before_func;
	stub_after_func_40 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[40];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_40)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_40)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname) : -ENOSYS);

	    after_func = (stub_after_func_40)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'dup' (41). */
asmlinkage static int
stub_syscall_41(int oldfd) {
	typedef int
		(*stub_func_41)(int oldfd);
	typedef int
		(*stub_before_func_41)(int oldfd, int* syscall_rc); 
	typedef int
		(*stub_after_func_41)(int syscall_rc, int oldfd);
	stub_func_41 orig_syscall_func;
	stub_before_func_41 before_func;
	stub_after_func_41 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[41];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_41)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldfd , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_41)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(oldfd) : -ENOSYS);

	    after_func = (stub_after_func_41)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, oldfd);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'chroot' (61). */
asmlinkage static int
stub_syscall_61(const char* path) {
	typedef int
		(*stub_func_61)(const char* path);
	typedef int
		(*stub_before_func_61)(const char* path, int* syscall_rc); 
	typedef int
		(*stub_after_func_61)(int syscall_rc, const char* path);
	stub_func_61 orig_syscall_func;
	stub_before_func_61 before_func;
	stub_after_func_61 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[61];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_61)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(path , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_61)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(path) : -ENOSYS);

	    after_func = (stub_after_func_61)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, path);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'dup2' (63). */
asmlinkage static int
stub_syscall_63(int oldfd, int newfd) {
	typedef int
		(*stub_func_63)(int oldfd, int newfd);
	typedef int
		(*stub_before_func_63)(int oldfd, int newfd, int* syscall_rc); 
	typedef int
		(*stub_after_func_63)(int syscall_rc, int oldfd, int newfd);
	stub_func_63 orig_syscall_func;
	stub_before_func_63 before_func;
	stub_after_func_63 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[63];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_63)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldfd, newfd , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_63)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(oldfd, newfd) : -ENOSYS);

	    after_func = (stub_after_func_63)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, oldfd, newfd);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'symlink' (83). */
asmlinkage static int
stub_syscall_83(const char* oldpath, const char* newpath) {
	typedef int
		(*stub_func_83)(const char* oldpath, const char* newpath);
	typedef int
		(*stub_before_func_83)(const char* oldpath, const char* newpath, int* syscall_rc); 
	typedef int
		(*stub_after_func_83)(int syscall_rc, const char* oldpath, const char* newpath);
	stub_func_83 orig_syscall_func;
	stub_before_func_83 before_func;
	stub_after_func_83 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[83];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_83)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldpath, newpath , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_83)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(oldpath, newpath) : -ENOSYS);

	    after_func = (stub_after_func_83)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, oldpath, newpath);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'settimeofday' (79). */
asmlinkage static int
stub_syscall_79(const struct timeval* tv, struct timezone* tz) {
	typedef int
		(*stub_func_79)(const struct timeval* tv, struct timezone* tz);
	typedef int
		(*stub_before_func_79)(const struct timeval* tv, struct timezone* tz, int* syscall_rc); 
	typedef int
		(*stub_after_func_79)(int syscall_rc, const struct timeval* tv, struct timezone* tz);
	stub_func_79 orig_syscall_func;
	stub_before_func_79 before_func;
	stub_after_func_79 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[79];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_79)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(tv, tz , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_79)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(tv, tz) : -ENOSYS);

	    after_func = (stub_after_func_79)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, tv, tz);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'getpriority' (96). */
asmlinkage static int
stub_syscall_96(int which, int who) {
	typedef int
		(*stub_func_96)(int which, int who);
	typedef int
		(*stub_before_func_96)(int which, int who, int* syscall_rc); 
	typedef int
		(*stub_after_func_96)(int syscall_rc, int which, int who);
	stub_func_96 orig_syscall_func;
	stub_before_func_96 before_func;
	stub_after_func_96 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[96];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_96)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(which, who , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_96)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(which, who) : -ENOSYS);

	    after_func = (stub_after_func_96)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, which, who);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'setpriority' (97). */
asmlinkage static int
stub_syscall_97(int which, int who, int pro) {
	typedef int
		(*stub_func_97)(int which, int who, int pro);
	typedef int
		(*stub_before_func_97)(int which, int who, int pro, int* syscall_rc); 
	typedef int
		(*stub_after_func_97)(int syscall_rc, int which, int who, int pro);
	stub_func_97 orig_syscall_func;
	stub_before_func_97 before_func;
	stub_after_func_97 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[97];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_97)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(which, who, pro , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_97)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(which, who, pro) : -ENOSYS);

	    after_func = (stub_after_func_97)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, which, who, pro);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'setuid' (213). */
asmlinkage static int
stub_syscall_213(uid_t uid) {
	typedef int
		(*stub_func_213)(uid_t uid);
	typedef int
		(*stub_before_func_213)(uid_t uid, int* syscall_rc); 
	typedef int
		(*stub_after_func_213)(int syscall_rc, uid_t uid);
	stub_func_213 orig_syscall_func;
	stub_before_func_213 before_func;
	stub_after_func_213 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[213];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_213)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(uid , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_213)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(uid) : -ENOSYS);

	    after_func = (stub_after_func_213)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, uid);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'socketcall' (102). */
asmlinkage static int
stub_syscall_102(int call, unsigned long* args) {
	typedef int
		(*stub_func_102)(int call, unsigned long* args);
	typedef int
		(*stub_before_func_102)(int call, unsigned long* args, int* syscall_rc); 
	typedef int
		(*stub_after_func_102)(int syscall_rc, int call, unsigned long* args);
	stub_func_102 orig_syscall_func;
	stub_before_func_102 before_func;
	stub_after_func_102 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[102];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_102)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(call, args , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_102)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(call, args) : -ENOSYS);

	    after_func = (stub_after_func_102)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, call, args);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}


/* pointers to stub functions - to be used */
/* when hijacking system calls.            */
func_ptr stub_functions[] = {
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_5,
	(func_ptr)stub_syscall_6,
	(func_ptr)stub_syscall_7,
	(func_ptr)stub_syscall_8,
	(func_ptr)stub_syscall_9,
	(func_ptr)stub_syscall_10,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_12,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_15,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_19,
	(func_ptr)stub_syscall_20,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_33,
	(func_ptr)stub_syscall_34,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_37,
	(func_ptr)stub_syscall_38,
	(func_ptr)stub_syscall_39,
	(func_ptr)stub_syscall_40,
	(func_ptr)stub_syscall_41,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_61,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_63,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_79,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_83,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_96,
	(func_ptr)stub_syscall_97,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_102,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_213,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
};
