/*
 * $Id: tracker_sysctl.c,v 1.5 2002/02/01 07:09:16 chooga Exp $
 */ 

#include <linux/kernel.h>
#include <linux/errno.h>
#include <asm/semaphore.h>

#include "rule_engine_public.h"
#include "sct_rules_private.h"
#include "tracker_sysctl.h"
#include "update_rules.h"

/* adds a new rule for a given system call. */
int tracker_sysctl_add_rule(int rule_id,
			    sct_rule_when_t when,
			    int syscall_id,
			    int mux_func_id,
			    sct_filter_node_t* f,
			    sct_action_t* a)
{
	return tracker_add_rule(rule_id, when, syscall_id, 
				mux_func_id, f, a);
}

/* deletes an existing rule for a given system call. */
int tracker_sysctl_del_rule(int rule_id,
			    sct_rule_when_t when,
			    int syscall_id,
			    int mux_func_id)
{
	return tracker_del_rule(rule_id, when, syscall_id, mux_func_id);
}

/* deletes all existing rules for a given system call. */
/* TODO - handle muxed functions as if they were real syscalls. */
int tracker_sysctl_del_all_rules_for_syscall(int syscall_id, int mux_func_id)
{
	return tracker_del_all_rules_for_syscall(syscall_id, mux_func_id);
}

/* deletes all existing rules in the module */
int tracker_sysctl_del_all_module_rules(void)
{
	return tracker_del_all_module_rules();
}

/* prints all existing rules in the module */
int tracker_sysctl_print_all_rules(void)
{
	return tracker_print_all_rules();
}
