/*
 * $Id: update_rules.h,v 1.3 2002/01/20 22:20:00 mulix Exp $
 */

#ifndef UPDATE_RULES_H_
#define UPDATE_RULES_H_

#include "sct_rules_private.h"
#include "rule_engine_public.h"

int tracker_build_rule(unsigned char* buf, int len, int* rule_id, 
		       sct_rule_when_t* when, int* syscall_id, 
		       int* mux_func_id, sct_action_t** act, 
		       sct_filter_node_t** f);

int sanity_check_user_input(int syscall_id, int mux_func_id, 
			    sct_rule_when_t when);

int tracker_add_rule(int rule_id, sct_rule_when_t when, int syscall_id,
		     int mux_func_id, sct_filter_node_t* f, sct_action_t* a);

int tracker_del_rule(int rule_id, sct_rule_when_t when, int syscall_id,
		     int mux_func_id);

/* deletes all existing rules for a given system call. */
/* TODO - handle muxed functions as if they were real syscalls. */
int tracker_del_all_rules_for_syscall(int syscall_id, int mux_func_id);

/* deletes all existing rules in the module */
int tracker_del_all_module_rules(void);

/* prints all existing rules in the module */
int tracker_print_all_rules(void);

#endif /* UPDATE_RULES_H_ */
